void lddif (double th[],double zz[],double yyy[],double ee[],int mm,int nn,double CC,double LL,double dd, double *initpp);

#define S_FUNCTION_NAME lddif_c
#define S_FUNCTION_LEVEL 2

#include "simstruc.h"
#include "lddif.c"

#define U(element) (*uPtrs[element])  /* Pointer to Input Port0 */


#define Np(S) ssGetSFcnParam(S,0)       //number of identification parameters
#define No(S) ssGetSFcnParam(S,1)       //number of outputs
#define Ex(S) ssGetSFcnParam(S,2)       //Exponencial forgeting
#define D(S) ssGetSFcnParam(S,3)        //Bittanti's correction
#define pom(S) ssGetSFcnParam(S,4)      //poc.parametre
#define C(S) ssGetSFcnParam(S,5)        //Covariance matrix
#define Ts(S) ssGetSFcnParam(S,6)       //Sampling time

#define NPARAMS 7
int np,no,TS,PP,OP,ninput,nv;
double C,L,d;
double *pom=NULL;
double *theta=NULL;



/*====================*
 * S-function methods *
 *====================*/

 #define MDL_CHECK_PARAMETERS
#if defined(MDL_CHECK_PARAMETERS) && defined(MATLAB_MEX_FILE)
  /* Function: mdlCheckParameters =============================================
   * Abstract:
   *    Validate our parameters to verify they are okay.
   */
  static void mdlCheckParameters(SimStruct *S)
  {
      /* Check 1st parameter: Np (No.of estimated parameters) */
      {
          if (!mxIsDouble(Np(S)) || mxGetNumberOfElements(Np(S)) != 1) 
            {
              ssSetErrorStatus(S,"1st parameter to S-function must be a "
                               "No.of estimated parameters");
              return;
            }
      }
      
      /* Check 2nd parameter: No (No.of outputs) */
      {
          if (!mxIsDouble(No(S)) || mxGetNumberOfElements(No(S)) != 1)
            {
              ssSetErrorStatus(S,"2nd parameter to S-function must be a "
                               "No.of outputs");
              return;
            }
      }
       /* Check 3rd parameter: Ex (Exp. forgeting) */
      {
          if (!mxIsDouble(Ex(S)) || mxGetNumberOfElements(Ex(S)) != 1)
            {
              ssSetErrorStatus(S,"3rd parameter to S-function must be a "
                               "Exp. forgeting");
              return;
            }
      }
       /* Check 4th parameter: D (Bittanti's correction) */
      {
          if (!mxIsDouble(D(S)) || mxGetNumberOfElements(D(S)) != 1)
            {
              ssSetErrorStatus(S,"4th parameter to S-function must be a "
                               "Bittanti's correction");
              return;
            }
      }
       /* Check 5th parameter: pom (initial parameters) */
      {
          if (!mxIsDouble(pom(S)) || mxGetNumberOfElements(pom(S)) != 1)
            {
              ssSetErrorStatus(S,"5th parameter to S-function must be a "
                               "initial parameters");
              return;
            }
      }
       /* Check 6th parameter: C (Covariance matrix) */
      {
          if (!mxIsDouble(C(S)) || mxGetNumberOfElements(C(S)) != 1)
            {
              ssSetErrorStatus(S,"6th parameter to S-function must be a "
                               "Covariance matrix");
              return;
            }
      }
       /* Check 7th parameter: Ts (Sampling time) */
      {
          if (!mxIsDouble(Ts(S)) || mxGetNumberOfElements(Ts(S)) != 1)
            {
              ssSetErrorStatus(S,"7th parameter to S-function must be a "
                               "Sampling time");
              return;
            }
      }
 }
#endif /* MDL_CHECK_PARAMETERS */

 
/* Function: mdlInitializeSizes ===============================================
 * Abstract:
 *    The sizes information is used by Simulink to determine the S-function
 *    block's characteristics (number of inputs, outputs, states, etc.).
 */
static void mdlInitializeSizes(SimStruct *S)
{
    int_T i;
    ssSetNumSFcnParams(S, NPARAMS);  /* Number of expected parameters */
    if (ssGetNumSFcnParams(S) != ssGetSFcnParamsCount(S)) {
        return; /* Parameter mismatch will be reported by Simulink */
    }
          
    np = *mxGetPr(Np(S));               //number of ident. parameters
    no = *mxGetPr(No(S));               //number of outputs
    L = *mxGetPr(Ex(S));                
    d = *mxGetPr(D(S));                 
    pom = mxGetPr(pom(S));              
    C =  *mxGetPr(C(S));
    TS = *mxGetPr(Ts(S));
    
    ssSetNumContStates(S, 0);
    ssSetNumDiscStates(S, np*no);
           
    //Vypis parametrov.
    //printf("Pocet parametrov je: %d\n",S->sfcnParams.dlgNum);
    //printf("Stupen citatela je:%d\n",SC);
    //printf("Stupen menovatela je:%d\n",SM);
    //printf("Perioda vzorkovania je:%d",TS);

    if (!ssSetNumInputPorts(S, 1)) return;
	ninput = np+no;
    ssSetInputPortWidth(S, 0, ninput);
    ssSetInputPortDirectFeedThrough(S, 0, 1);

    theta = (double*)malloc((size_t)(np*no)*sizeof(double));
    
    if (!ssSetNumOutputPorts(S, 1)) return;
    
    //OP = (np+2)*(np)+np+1;
    nv = np*no+(np*np)+no;
    ssSetOutputPortWidth(S, 0, nv);

    ssSetNumSampleTimes(S, 1);
    ssSetNumRWork(S, 0);
    ssSetNumIWork(S, 0);
    ssSetNumPWork(S, 0);
    ssSetNumModes(S, 0);
    ssSetNumNonsampledZCs(S, 0);

    /* Take care when specifying exception free code - see sfuntmpl.doc */
    ssSetOptions(S, SS_OPTION_EXCEPTION_FREE_CODE);
}



/* Function: mdlInitializeSampleTimes =========================================
 * Abstract:
 *    Specifiy that we inherit our sample time from the driving block.
 */
static void mdlInitializeSampleTimes(SimStruct *S)
{
    ssSetSampleTime(S, 0, TS);
    ssSetOffsetTime(S, 0, 0.0);
}



#define MDL_INITIALIZE_CONDITIONS
/* Function: mdlInitializeConditions ========================================
 * Abstract:
 *    Initialize both continuous states to zero.
 */
static void mdlInitializeConditions(SimStruct *S)
{
    real_T *x0 = ssGetRealDiscStates(S);
    int_T  lp;

    for (lp=0;lp<2;lp++) { 
        *x0++=1.0;
    }
}



/* Function: mdlOutputs =======================================================
 * Abstract:
 *      y = Cx + Du 
 */
static void mdlOutputs(SimStruct *S, int_T tid)
{
    int_T i,j=0;
    double *yy; 
    //double z[2];
    double *e;
    //static double theta[2];
    double *z=NULL;
    
    
	
    real_T            *y    = ssGetOutputPortRealSignal(S,0);
    real_T            *x    = ssGetRealDiscStates(S);
    InputRealPtrsType uPtrs = ssGetInputPortRealSignalPtrs(S,0);
    //int_T              width= ssGetOutputPortWidth(S,0);
    
    
    z = (double*)malloc((size_t)(np)*sizeof(double));
    yy = (double*)malloc((size_t)no*sizeof(double));
    e = (double*)malloc((size_t)no*sizeof(double));
    /* y=Cx+Du */
    
    
    for(i=0;i<no;i++)
    {
        yy[i] = U(i);  // y
        //printf("yy%d=%lf\n",i,U(i));
    }
    for(i;i<np+no;i++)
    {
        z[j++]  = U(i);
        //printf("derivacie =%lf\n",U(i));
    }
    //printf("\n");
    /*z[0]  = U(1);  // -y'
    z[1]  = U(2);  // u*/

    lddif(theta, z, yy, e, no, np, C, L, d, pom);
    
    for(i=0;i<np*no;i++)
    {
        y[i]=theta[i];
        //printf("theta_index = %d\n",i);
    }
    j=0;
    for(i;i<np*np+np*no;i++)
    {
        y[i]=p[j++];
        //printf("cov_index = %d\n",i);
    }
    j=0;
    for(i;i<np*np+np*no+no;i++)
        y[i]=e[j++];
    //printf("ecko = %d\n",i);
    /*y[0]=theta[0];
    y[1]=theta[1];*/
	free(z);
    free(e);
    free(yy);
    z=e=yy=NULL;
}



#define MDL_UPDATE
/* Function: mdlUpdate ======================================================
 * Abstract:
 *      xdot = Ax + Bu
 */
static void mdlUpdate(SimStruct *S, int_T tid)
{
    real_T            tempX[2] = {0.0, 0.0};
    real_T            *x       = ssGetRealDiscStates(S);
    InputRealPtrsType uPtrs    = ssGetInputPortRealSignalPtrs(S,0);
    int_T i;

    /* xdot=Ax+Bu */
    
    for(i=0;i<np*no;i++)
    {
        x[i]=x[i];
    }
    
    /*x[0]=x[0];
    x[1]=x[1];*/
}



/* Function: mdlTerminate =====================================================
 * Abstract:
 *    No termination needed, but we are required to have this routine.
 */
static void mdlTerminate(SimStruct *S)
{
    free(theta);
    free(p);
    theta = NULL;
    p = NULL;
    init++;
    
}

#ifdef  MATLAB_MEX_FILE    /* Is this file being compiled as a MEX-file? */
#include "simulink.c"      /* MEX-file interface mechanism */
#else
#include "cg_sfun.h"       /* Code generation registration function */
#endif
